// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DirectDisk.pas' rev: 3.00

#ifndef DirectDiskHPP
#define DirectDiskHPP
#include <DDVerc.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Directdisk
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct DiskInformation
{
	Word BytesPerSector;
	Byte SectorsPerCluster;
	Word ReservedSectors;
	Byte FATs;
	Word RootDirectories;
	Word TotalSectors;
	Byte MediaDescriptor;
	Word SectorsPerFAT;
	Word SectorsPerTrack;
	Word Heads;
} ;
#pragma pack(pop)

enum TFloppyType { DUnknown, D360, D1200, D720, D1440 };

typedef DiskInformation DiskInfoArray[5];

typedef Shortint TRetries;

class DELPHICLASS TDirDisk;
class PASCALIMPLEMENTATION TDirDisk : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::AnsiString DDV;
	Byte WP;
	Word WB;
	char Disk;
	Cardinal FirstSectorNum;
	Cardinal SectorsNum;
	int iSectorsPerCluster;
	int iBytesPerSector;
	int iNumberOfFreeClusters;
	int iTotalNumberOfClusters;
	bool ToDiskLock;
	bool IsNeedWarning;
	bool IsTrueDisk;
	TRetries FRetries;
	void __fastcall SetDDV(System::AnsiString Istr);
	Byte __fastcall GetWinPlatform(void);
	void __fastcall SetDisk(char DiskChr);
	bool __fastcall GetDiskInfo(char DName);
	void __fastcall SetSectors(Cardinal Secs);
	void __fastcall SetFirstSector(Cardinal FirstSec);
	bool __fastcall GetDeviceHandle(void);
	bool __fastcall GetDiskHandle(char CDrive);
	bool __fastcall RS95(int DriveNo, int FirstSector, int NumberOfSectors, void * Buf);
	bool __fastcall WS95(int DriveNo, int FirstSector, int NumberOfSectors, void * Buf);
	bool __fastcall RSNT(char DriveChar, int AFirstByte, int NumberOfBytes, Byte * lpBuffer, const int 
		lpBuffer_Size);
	bool __fastcall WSNT(char DriveChar, int AFirstByte, int NumberOfBytes, const Byte * lpBuffer, const 
		int lpBuffer_Size);
	int __fastcall RF95(Byte Drive, Byte Head, Byte Track, Byte Sector, void * Buffer);
	int __fastcall WF95(Byte Drive, Byte Head, Byte Track, Byte Sector, void * Buffer);
	int __fastcall GetDriveNo(char DiskChar);
	void __fastcall FreeHandle(void);
	
public:
	__fastcall virtual TDirDisk(Classes::TComponent* AOwner);
	__fastcall virtual ~TDirDisk(void);
	__property Byte WinPlatform = {read=WP, nodefault};
	__property Word WinBuild = {read=WB, nodefault};
	__property int SectorsPerCluster = {read=iSectorsPerCluster, nodefault};
	__property int BytesPerSector = {read=iBytesPerSector, nodefault};
	__property int NumberOfFreeClusters = {read=iNumberOfFreeClusters, nodefault};
	__property int TotalNumberOfClusters = {read=iTotalNumberOfClusters, nodefault};
	__property bool TrueDisk = {read=IsTrueDisk, nodefault};
	bool __fastcall ReadSectors(Byte * B, const int B_Size);
	bool __fastcall WriteSectors(const Byte * B, const int B_Size);
	bool __fastcall ReadFloppySectors(char DriveChar, Byte * B, const int B_Size, TFloppyType FMediaType
		);
	bool __fastcall WriteFloppySectors(char DriveChar, const Byte * B, const int B_Size, TFloppyType FMediaType
		, bool NeedDismount);
	
__published:
	__property System::AnsiString About = {read=DDV, write=SetDDV};
	__property char DriveName = {read=Disk, write=SetDisk, default=67};
	__property Cardinal FirstSector = {read=FirstSectorNum, write=SetFirstSector, default=0};
	__property Cardinal Sectors = {read=SectorsNum, write=SetSectors, default=1};
	__property bool NeedDiskLock = {read=ToDiskLock, write=ToDiskLock, default=0};
	__property bool NeedWriteWarn = {read=IsNeedWarning, write=IsNeedWarning, default=1};
	__property TRetries Retries = {read=FRetries, write=FRetries, default=2};
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::AnsiString AttentionText;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Directdisk */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Directdisk;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// DirectDisk
